diff --git a/lib/hive/daemon/recoverable_signatures.rb b/lib/hive/daemon/recoverable_signatures.rb
new file mode 100644
index 000000000..5db15c790
--- /dev/null
+++ b/lib/hive/daemon/recoverable_signatures.rb
@@ -0,0 +1,110 @@
+require "hive/diagnostic_helpers"
+require "hive/paths"
+
+module Hive
+  module Daemon
+    # Classifies the two v1 allowlisted recoverable terminal-error signatures
+    # from on-disk evidence (marker attrs + task/global log tails). Everything
+    # else — business-logic failures, test failures, review findings, merge
+    # conflicts, dirty-worktree failures, and unknown `exit_code=1` — returns
+    # false so the healer never auto-clears it.
+    #
+    # The Codex 401 shape is the ONLY admitted `implementer_failed` variant:
+    # the marker `message` or the captured implementer output must carry `401`
+    # together with `bearer`/`basic auth` (case-insensitive), or the literal
+    # Codex `Missing bearer/basic auth` string. `claude_launch_failed` needs no
+    # extra text classification — the reason itself is the signature; the
+    # probe (not text) is its gate.
+    module RecoverableSignatures
+      LOG_GLOB_CAP = 20
+
+      module_function
+
+      # Three-state classification for the healer: `:codex_auth` when the
+      # implementer_failed marker carries the Codex-401 diagnostic signature,
+      # `:claude_launcher` for the claude_launch_failed reason, else nil
+      # (never auto-clear).
+      def classify(row, state_home: nil)
+        reason = marker_reason(row)
+        return :codex_auth if reason == "implementer_failed" && codex_auth_text?(evidence_text(row, state_home: state_home))
+
+        return :claude_launcher if reason == "claude_launch_failed"
+
+        nil
+      end
+
+      # The only admitted `implementer_failed` shape: the marker's message
+      # AND the captured implementer output (task logs + global per-slug log)
+      # carry the Codex `Missing bearer/basic auth` / `401 + auth` signature.
+      def codex_auth_failure?(row, state_home: nil)
+        marker_reason(row) == "implementer_failed" &&
+          codex_auth_text?(evidence_text(row, state_home: state_home))
+      end
+
+      def claude_launch_signature?(row)
+        marker_reason(row) == "claude_launch_failed"
+      end
+
+      # Text predicate shared by the classifier and its tests. Accepts the
+      # literal Codex `Missing bearer/basic auth` string, or a `401` token
+      # appearing together with a `bearer`/`basic auth` token.
+      def codex_auth_text?(text)
+        text = text.to_s
+        return true if text.match?(/Missing bearer\/basic auth/i)
+
+        text.match?(/401/) && text.match?(/bearer|basic auth/i)
+      end
+
+      def evidence_text(row, state_home:)
+        [
+          marker_message(row),
+          task_log_tails(row),
+          state_log_tails(row, state_home: state_home)
+        ].flatten.compact.join("\n")
+      end
+
+      def marker_reason(row)
+        marker_attrs(row)["reason"].to_s
+      end
+
+      def marker_message(row)
+        marker_attrs(row)["message"].to_s
+      end
+
+      def marker_attrs(row)
+        return {} unless row.respond_to?(:marker_attrs)
+
+        attrs = row.marker_attrs
+        attrs.is_a?(Hash) ? attrs : {}
+      end
+
+      # Bounded tail scan of `<task.folder>/logs/*.log`. Non-regular files
+      # (FIFOs, sockets) are skipped so the scan can never block a tick.
+      def task_log_tails(row)
+        return [] unless row.respond_to?(:folder) && row.folder
+
+        log_tails(File.join(row.folder.to_s, "logs"))
+      end
+
+      # Bounded tail scan of the global `<state_home>/logs/<slug>/*.log` dir.
+      def state_log_tails(row, state_home:)
+        return [] unless row.respond_to?(:slug) && row.slug
+
+        home = state_home || Hive::Paths.state_home
+        log_tails(File.join(home.to_s, "logs", row.slug.to_s))
+      end
+
+      def log_tails(dir)
+        Dir[File.join(dir, "*.log")].sort.first(LOG_GLOB_CAP).filter_map { |path| tail_file(path) }
+      end
+
+      def tail_file(path)
+        return nil unless File.file?(path)
+
+        Hive::DiagnosticHelpers.tail_file(path)
+      rescue SystemCallError, IOError
+        nil
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/stale_agent_healer.rb b/lib/hive/daemon/stale_agent_healer.rb
index 02042f789..c2ab8a2e3 100644
--- a/lib/hive/daemon/stale_agent_healer.rb
+++ b/lib/hive/daemon/stale_agent_healer.rb
@@ -2,10 +2,18 @@ require "digest"
 require "open3"
 require "time"
 require "yaml"
+require "hive/agent_profiles"
+require "hive/brainstorm_parser"
+require "hive/config"
+require "hive/events"
 require "hive/lock"
 require "hive/markers"
 require "hive/workflows"
+require "hive/worktree"
 require "hive/daemon/dispatch_request_queue"
+require "hive/daemon/health_probe"
+require "hive/daemon/health_signals"
+require "hive/daemon/recoverable_signatures"
 
 module Hive
   module Daemon
@@ -97,6 +105,17 @@ module Hive
       # because a timeout means "I ran and didn't finish", not "I was interrupted".
       TIMEOUT_RECOVERY_LIMIT = 1
       TIMEOUT_RECOVERABLE_STAGES = %w[5-open-pr 7-artifacts].freeze # coding-scoped: coding stages whose timeout re-entry is idempotent
+      # Probe-gated auto-retry (v1): `implementer_failed` (Codex 401) and
+      # `claude_launch_failed` (launcher healthy) recover at most twice per
+      # task/reason, backoff immediate then 30 min, and only ever re-probe on
+      # a changed health signal plus a low-frequency fallback.
+      RECOVERABLE_MARKER_RETRY_LIMIT = 2
+      RETRY_BACKOFF_SEC = 1800
+      PROBE_FALLBACK_SEC = 1800
+      WORKTREE_OWNING_STAGES = %w[4-execute 6-review 8-finalize].freeze # coding-scoped: stages whose retry safety gate must verify a clean worktree
+      # coding-scoped: stages whose state file holds user-answerable content;
+      # a from-scratch rerun must verify no answered content would be overwritten.
+      ANSWER_CONTENT_STAGES = %w[2-brainstorm 3-plan].freeze
 
       # Review fix-phase auto-commit failures that a bounded rerun can clear:
       # the fix agent left residue the scope check rejected, or a transient
@@ -115,7 +134,14 @@ module Hive
       def initialize(controller:, logger:, grace_sec: 300,
                      review_error_auto_recovery_limit: REVIEW_ERROR_AUTO_RECOVERY_LIMIT,
                      error_auto_recovery_limit: ERROR_AUTO_RECOVERY_LIMIT,
-                     request_queue: Hive::Daemon::DispatchRequestQueue)
+                     request_queue: Hive::Daemon::DispatchRequestQueue,
+                     probe: nil,
+                     signal_cache: nil,
+                     auto_retry_enabled: true,
+                     state_home: nil,
+                     env: nil,
+                     project_config_resolver: nil,
+                     code_fingerprint: nil)
         @controller = controller
         @logger = logger
         @request_queue = request_queue
@@ -126,6 +152,23 @@ module Hive
         @error_auto_recoveries = Hash.new(0)
         @review_error_recovery_exhausted = {}
         @error_recovery_exhausted = {}
+        @probe = probe
+        @signal_cache = signal_cache || Hive::Daemon::HealthSignalCache.new
+        @auto_retry_enabled = auto_retry_enabled
+        @state_home = state_home
+        @env = (env || ENV.to_h).to_h
+        @project_config_resolver = project_config_resolver
+        # Loaded-code baseline (the daemon's startup digest of lib/hive.rb),
+        # passed through to the launcher probe so it can verify the loaded
+        # code matches the on-disk lib/hive.rb before retrying.
+        @code_fingerprint = code_fingerprint
+        # Per-process retry budget/backoff/fingerprint for the probe-gated
+        # reasons (documented `budget_scope=per_process`, matching the other
+        # healer budgets). Keyed by [project, slug, stage, reason].
+        @probe_retry_state = {}
+        # One-shot throttled-negative dedup (once per fingerprint change).
+        @probe_blocked_logged = {}
+        @probe_exhausted_logged = {}
       end
 
       # Walk the row set, heal stale agent_working markers in place.
@@ -180,6 +223,19 @@ module Hive
 
       def heal_error_if_auto_recoverable(row, now:)
         return if row.live_task_lock == true
+
+        # Probe-gated auto-retry for the two v1 recoverable markers. This is
+        # a NARROW extension: only `implementer_failed` with a recognized
+        # Codex-401 signature, or `claude_launch_failed` — both require a
+        # health probe to pass, a changed health-signal fingerprint, a clean
+        # work area, and a stricter retry budget (2) with backoff. Everything
+        # else falls through to the existing marker-shape heuristics below.
+        probe_reason = probe_gated_reason(row)
+        if probe_reason
+          heal_probe_gated_error(row, now: now, probe_reason: probe_reason)
+          return
+        end
+
         return unless auto_recoverable_error?(row, now: now)
         # The clear makes a markerless terminal-error row take the
         # edit-resume path; without a pre-clear mtime to seed as the
@@ -285,6 +341,343 @@ module Hive
                       remediation: "hive plan #{row.slug} --project #{row.project} --from 3-plan") # coding-scoped: healer re-enters coding plan verb
       end
 
+      # --- probe-gated auto-retry (v1) ------------------------------------
+
+      # Three-state classification for the two probe-gated reasons. nil when
+      # auto-retry is disabled, the probe seam is unwired, or the row is not
+      # one of the two allowlisted signatures.
+      def probe_gated_reason(row)
+        return nil unless @probe && @auto_retry_enabled
+
+        Hive::Daemon::RecoverableSignatures.classify(row, state_home: @state_home)
+      end
+
+      # Probe-first, changed-signal, safety-gated, budgeted retry. The outer
+      # `heal` loop already skips live_task_lock / running_task? /
+      # half-migrated projects; live_task_lock is re-checked by the caller.
+      def heal_probe_gated_error(row, now:, probe_reason:)
+        return if row.state_file_mtime.nil?
+
+        retry_key = probe_retry_key(row, probe_reason)
+        cache_key = probe_cache_key(row, probe_reason)
+        state = (@probe_retry_state[retry_key] ||= {
+          attempts: 0, last_fingerprint: nil, last_attempt_at: nil, last_probe_at: nil
+        })
+        context = probe_context_for(row, probe_reason)
+        # The fingerprint hashes lib/hive.rb plus recursive skill-inventory
+        # globs, so N parked rows sharing a (reason, project) must not repeat
+        # it N times per tick. Memoize it per tick alongside the probe
+        # results (R6: cheap, cached fingerprint).
+        fingerprint = @signal_cache.fingerprint(cache_key) do
+          Hive::Daemon::HealthSignals.fingerprint(
+            cfg: context[:cfg], project_root: context[:project_root],
+            profile: context[:profile], wrapper_path: context[:wrapper_path],
+            env: context[:env]
+          )
+        end
+
+        # Capture the changed-signal flag BEFORE `probe_results_for` runs:
+        # that method overwrites `state[:last_fingerprint]` with the current
+        # fingerprint (on both the probe and memo-hit paths), so recomputing
+        # it afterwards would always see "unchanged" and block a changed-signal
+        # retry as "backoff" — exactly the opposite of the plan's escape.
+        signal_changed = state[:last_fingerprint].nil? || state[:last_fingerprint] != fingerprint
+        results = probe_results_for(cache_key, retry_key, state, context, row,
+                                    fingerprint, probe_reason, now: now)
+        return if results.nil? # throttled negative already logged
+
+        unless results_healthy?(results)
+          log_probe_blocked_once(retry_key, fingerprint, row, probe_reason,
+                                 rationale: "probe not healthy", probe_detail: probe_detail(results))
+          return
+        end
+
+        unless safe_to_retry?(row)
+          log_probe_blocked_once(retry_key, fingerprint, row, probe_reason, rationale: "unsafe work area")
+          return
+        end
+
+        if state[:attempts] >= RECOVERABLE_MARKER_RETRY_LIMIT
+          log_probe_exhausted_once(retry_key, row, probe_reason, state)
+          return
+        end
+
+        if state[:attempts].positive? && state[:last_attempt_at] &&
+           (now - state[:last_attempt_at]) < RETRY_BACKOFF_SEC && !signal_changed
+          log_probe_blocked_once(retry_key, fingerprint, row, probe_reason, rationale: "backoff")
+          return
+        end
+
+        marker_reason = probe_marker_reason(probe_reason)
+        return unless Hive::Markers.clear_current(
+          row.state_file,
+          expected_name: :error,
+          match_attrs: auto_recoverable_error_match_attrs(row, reason: marker_reason)
+        )
+
+        observe_pre_clear_mtime(row)
+        state[:attempts] += 1
+        state[:last_attempt_at] = now
+        state[:last_fingerprint] = fingerprint
+        heal_label = probe_heal_label(probe_reason)
+        @logger.event(:marker_healed,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      prior_marker: row.marker,
+                      reason: heal_label,
+                      marker_reason: marker_reason,
+                      state_file: row.state_file,
+                      fingerprint: fingerprint,
+                      probes: probe_summaries(results),
+                      attempts: state[:attempts],
+                      max_attempts: RECOVERABLE_MARKER_RETRY_LIMIT)
+        emit_auto_retry_event(row, probe_reason, results, fingerprint, state)
+        # 3-plan needs the explicit requeue exactly like the other heals — a
+        # markerless empty plan.md re-classifies straight back to :error.
+        requeue_plan_rerun(row) if Hive::Workflows.coding_row?(row) && row.stage.to_s == "3-plan" # coding-scoped: coding plan pause needs bespoke rerun after marker clear
+      rescue StandardError => e
+        @logger.event(:marker_heal_failed,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      reason: probe_heal_label(probe_reason),
+                      error: "#{e.class}: #{e.message}")
+      end
+
+      def probe_retry_key(row, probe_reason)
+        [ row.project.to_s, row.slug.to_s, row.stage.to_s, probe_reason.to_s ]
+      end
+
+      def probe_cache_key(row, probe_reason)
+        [ probe_reason.to_s, row.project.to_s ]
+      end
+
+      def probe_context_for(row, probe_reason)
+        cfg, project_root = resolve_project_config(row.project)
+        {
+          reason: probe_reason,
+          cfg: cfg || {},
+          project_root: project_root,
+          profile: probe_profile(probe_reason, cfg),
+          wrapper_path: Hive::Daemon::HealthProbe.wrapper_path,
+          env: @env
+        }
+      end
+
+      def resolve_project_config(project_name)
+        return @project_config_resolver.call(project_name) if @project_config_resolver
+
+        entry = Hive::Config.find_project(project_name)
+        return [ nil, nil ] if entry.nil?
+
+        [ Hive::Config.load(entry["path"]), entry["path"] ]
+      rescue Hive::ConfigError, StandardError
+        [ nil, nil ]
+      end
+
+      def probe_profile(probe_reason, cfg)
+        name = probe_reason == :codex_auth ? :codex : :claude
+        Hive::AgentProfiles.lookup(name, cfg: cfg)
+      end
+
+      # Universal precondition + reason-specific probe, both returned as
+      # `HealthProbe::Result` objects (never raised). The universal probe
+      # runs exactly once per probe cycle: `probe_claude_launcher` also runs
+      # it internally, so it receives the precomputed result instead of
+      # building a second `hive doctor` (R6: one doctor per cycle).
+      def run_probes(context, row)
+        universal = @probe.probe_universal(
+          config: context[:cfg], project_root: context[:project_root], stage: row.stage
+        )
+        { universal: universal, reason: reason_probe_result(context, row, universal) }
+      end
+
+      def reason_probe_result(context, row, universal)
+        if context[:reason] == :codex_auth
+          @probe.probe_codex_auth(env: context[:env])
+        else
+          @probe.probe_claude_launcher(
+            config: context[:cfg], project_root: context[:project_root],
+            env: context[:env], wrapper_path: context[:wrapper_path],
+            code_fingerprint: @code_fingerprint, stage: row.stage,
+            universal_result: universal
+          )
+        end
+      end
+
+      # Per-tick memo + changed-signal/fallback throttle. Returns the probe
+      # results hash, or nil when this tick is throttled (negative logged).
+      def probe_results_for(cache_key, retry_key, state, context, row, fingerprint, probe_reason, now:)
+        memo = @signal_cache.fetch(cache_key)
+        if memo && memo[:fingerprint] == fingerprint
+          # A memo hit means another row sharing this (reason, project) already
+          # ran the probes this tick. Record this row's retry-state bookkeeping
+          # too, otherwise its `last_probe_at`/`last_fingerprint` stay nil and
+          # the next tick's fallback check re-runs the expensive probes.
+          state[:last_fingerprint] = fingerprint
+          state[:last_probe_at] = now
+          return memo[:results]
+        end
+
+        signal_changed = state[:last_fingerprint].nil? || state[:last_fingerprint] != fingerprint
+        fallback_due = state[:last_probe_at].nil? || (now - state[:last_probe_at]) >= PROBE_FALLBACK_SEC
+        unless signal_changed || fallback_due
+          log_probe_blocked_once(retry_key, fingerprint, row, probe_reason, rationale: "signal unchanged")
+          return nil
+        end
+
+        results = run_probes(context, row)
+        @signal_cache.store(cache_key, fingerprint: fingerprint, results: results)
+        state[:last_fingerprint] = fingerprint
+        state[:last_probe_at] = now
+        results
+      end
+
+      def results_healthy?(results)
+        results.values.all? { |result| result.respond_to?(:healthy?) && result.healthy? }
+      end
+
+      def probe_detail(results)
+        results.map { |name, result| "#{name}=#{result.detail}" }.join("; ")
+      end
+
+      def probe_summaries(results)
+        results.map { |name, result| "#{name}:#{result.status}" }
+      end
+
+      def probe_heal_label(probe_reason)
+        probe_reason == :codex_auth ? "codex_auth_recovered" : "claude_launcher_recovered"
+      end
+
+      def probe_marker_reason(probe_reason)
+        probe_reason == :codex_auth ? "implementer_failed" : "claude_launch_failed"
+      end
+
+      # Safety gate: never retry when it could clobber user work. For
+      # worktree-owning stages the worktree must be clean (porcelain empty);
+      # brainstorm/plan stages hold user-answerable content in their state
+      # file and must be verified answer-free before a from-scratch rerun
+      # (fail closed: uncertain ⇒ skip); other stages are safe.
+      def safe_to_retry?(row)
+        return worktree_clean?(row) if WORKTREE_OWNING_STAGES.include?(row.stage.to_s)
+        return no_answered_content?(row) if ANSWER_CONTENT_STAGES.include?(row.stage.to_s)
+
+        true
+      end
+
+      # Fail-closed "no answered content to overwrite" guard for the
+      # brainstorm/plan stages. A from-scratch rerun of those stages rewrites
+      # their state file, so we only retry when we can PROVE it holds no
+      # user-provided answers. A missing state file is the one certainly-safe
+      # case (nothing to overwrite); an unreadable file, a leftover
+      # WAITING/COMPLETE marker, or (for brainstorm) any answered `### A{n}.`
+      # section all fail closed.
+      def no_answered_content?(row)
+        path = row.state_file
+        return true if path.nil? || !File.exist?(path)
+
+        content = File.read(path, encoding: "UTF-8").scrub
+        return false if content.match?(/<!--\s*(?:COMPLETE|WAITING)(?:\s|-->)/)
+        return false if row.stage.to_s == "2-brainstorm" && # coding-scoped: coding brainstorm answer format
+                        Hive::BrainstormParser.parse_text(content).any?(&:answered?)
+
+        true
+      rescue StandardError
+        false
+      end
+
+      def worktree_clean?(row)
+        path = worktree_path_for(row)
+        return false if path.nil? || !File.directory?(path)
+
+        out, _err, status = Open3.capture3("git", "-C", path, "status", "--porcelain")
+        return false unless status.success?
+
+        out.strip.empty?
+      rescue StandardError
+        false
+      end
+
+      def worktree_path_for(row)
+        return nil unless row.respond_to?(:folder) && row.folder
+
+        pointer = Hive::Worktree.read_pointer(row.folder)
+        pointer && pointer["path"]
+      rescue StandardError
+        nil
+      end
+
+      # Throttled negative: logged once per distinct [project, slug, stage,
+      # reason, fingerprint] so a persistently-unhealthy marker does not spam
+      # every tick.
+      def log_probe_blocked_once(retry_key, fingerprint, row, probe_reason, rationale:, probe_detail: nil)
+        dedup_key = retry_key + [ fingerprint ]
+        return if @probe_blocked_logged[dedup_key]
+
+        @probe_blocked_logged[dedup_key] = true
+        @logger.event(:auto_retry_blocked,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      reason: probe_heal_label(probe_reason),
+                      rationale: rationale,
+                      fingerprint: fingerprint,
+                      probe_detail: probe_detail)
+        emit_auto_retry_blocked_event(row, probe_reason, fingerprint, rationale, probe_detail)
+      end
+
+      def log_probe_exhausted_once(retry_key, row, probe_reason, state)
+        return if @probe_exhausted_logged[retry_key]
+
+        @probe_exhausted_logged[retry_key] = true
+        @logger.event(:marker_heal_exhausted,
+                      project: row.project,
+                      slug: row.slug,
+                      stage: row.stage,
+                      prior_marker: row.marker,
+                      state_file: row.state_file,
+                      reason: probe_heal_label(probe_reason),
+                      marker_reason: probe_marker_reason(probe_reason),
+                      attempts: state[:attempts],
+                      max_attempts: RECOVERABLE_MARKER_RETRY_LIMIT,
+                      budget_scope: "per_process",
+                      suggested_next_action: "manual_fix",
+                      remediation: probe_recovery_remediation(row, probe_reason))
+      end
+
+      def probe_recovery_remediation(row, probe_reason)
+        command = "hive run #{row.slug} --project #{row.project} --stage #{row.stage}"
+        dependency = probe_reason == :codex_auth ? "Codex auth" : "the Claude launcher"
+        "#{dependency} did not recover after #{RECOVERABLE_MARKER_RETRY_LIMIT} auto-retries — " \
+          "verify it manually, then rerun #{row.stage} (`#{command}`) or run `hive markers clear`"
+      end
+
+      def emit_auto_retry_event(row, probe_reason, results, fingerprint, state)
+        Hive::Events.emit(
+          task_folder: row.folder.to_s,
+          slug: row.slug.to_s,
+          stage: row.stage.to_s,
+          event_type: :auto_retry,
+          agent: "daemon",
+          message: "auto-retried #{probe_marker_reason(probe_reason)} " \
+                   "(attempt #{state[:attempts]}/#{RECOVERABLE_MARKER_RETRY_LIMIT}); " \
+                   "probes=#{probe_summaries(results).join(' ')}; fingerprint=#{fingerprint}"
+        )
+      end
+
+      def emit_auto_retry_blocked_event(row, probe_reason, fingerprint, rationale, probe_detail)
+        Hive::Events.emit(
+          task_folder: row.folder.to_s,
+          slug: row.slug.to_s,
+          stage: row.stage.to_s,
+          event_type: :auto_retry_blocked,
+          agent: "daemon",
+          message: "auto-retry blocked (#{rationale}) for #{probe_marker_reason(probe_reason)}; " \
+                   "fingerprint=#{fingerprint}#{probe_detail ? "; #{probe_detail}" : ''}"
+        )
+      end
+
       def auto_recoverable_error?(row, now:)
         reason = marker_reason(row)
         return true if Hive::Workflows.coding_row?(row) && row.stage.to_s == "8-finalize" && reason == "unpushed_commits" # coding-scoped: unpushed commits are finalize/PR recovery
diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index f8bca8160..1104c4981 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -15,6 +15,8 @@ module Hive
       round_complete
       clean_exit_auto_committed
       claude_completion_fallback
+      auto_retry
+      auto_retry_blocked
     ].freeze
 
     STATUS_TAIL_LINES = 20
